/* global localStorage */

"use strict";

exports.__esModule = true;
var nextTick = process && process.nextTick ? process.nextTick : setImmediate;

exports["default"] = {
  getItem: function getItem(key, cb) {
    try {
      var s = localStorage.getItem(key);
      nextTick(function () {
        cb(null, s);
      });
    } catch (e) {
      cb(e);
    }
  },
  setItem: function setItem(key, string, cb) {
    try {
      localStorage.setItem(key, string);
      nextTick(function () {
        cb(null);
      });
    } catch (e) {
      cb(e);
    }
  },
  removeItem: function removeItem(key, cb) {
    try {
      localStorage.removeItem(key);
      nextTick(function () {
        cb(null);
      });
    } catch (e) {
      cb(e);
    }
  },
  getAllKeys: function getAllKeys(cb) {
    try {
      var keys = [];
      for (var i = 0; i < localStorage.length; i++) {
        keys.push(localStorage.key(i));
      }
      nextTick(function () {
        cb(null, keys);
      });
    } catch (e) {
      cb(e);
    }
  }
};
module.exports = exports["default"];